//=============================================================================
//
//	Copyright (C) Hivertec Inc. 2000-2005
//	All rights reserved.
//
//	@(s)	Windows 9x, NT, 2000, XP 	HPCI-PPD553A series wb_[t@C
//
//  @(h)	hippd553.h	ver 3.0 ( 2005.05.06 HVT )
//
//=============================================================================
// ----------------------------------------------------------------------------
//	萔`
// ----------------------------------------------------------------------------
#define INVALID_BUS_NUMBER				(-1)		// ȃoXԍ
#define INVALID_DEV_NUMBER				(-1)		// ȃfoCXԍ
#define INVALID_IO_ADDRESS				0xFFFFFFFF	//  I/O AhX
#define INVALID_IRQ_NUMBER				(-1)		//  IRQ ԍ
#define INVALID_HPC_NUMBER				(-1)		// ȊǗԍ
#define INVALID_BOARD_ID				(-1)		// ȃ{[hID

#define ERROR_HPC_ALREADY_OPENED		0x20000001	//  HPCI foCXI[vς
#define ERROR_HPC_INVALID_HANDLE		0x20000002	// HPCI foCXID (nh)
#define ERROR_HPC_ALREADY_WAITING		0x20000003	// Ɋ荞ݑ҂Ԃɂ
#define ERROR_HPC_WAITING_CANCELED		0x20000004	// 荞ݑ҂LZꂽ
#define ERROR_HPC_ILLEGAL_DEVICE		0x20001000	// HPCIfoCXł͂Ȃ

// ----------------------------------------------------------------------------
//	\
// ----------------------------------------------------------------------------
typedef struct _HPCDEVICEINFO {				// foCX
	DWORD			nBusNumber;					// oXԍ
	DWORD			nDeviceNumber;				// foCXԍ
	DWORD			dwIoPortAddress;			// I/O |[gAhX
	DWORD			dwIrqNo;					// IRQ ԍ
	DWORD			dwNumber;					// Ǘԍ(Windows 95ł͖)
	DWORD			dwBoardID;					// {[hID			
} HPCDEVICEINFO, * PHPCDEVICEINFO;

typedef struct _HPCDEVICEINFOLIST {			// foCX񃊃Xg(foCX擾̂ݎgp)
	DWORD			nCount;						// ̌
	HPCDEVICEINFO	hpcDeviceInfo[1];			// foCX
} HPCDEVICEINFOLIST, * PHPCDEVICEINFOLIST;

// ----------------------------------------------------------------------------
//	萔`
// ----------------------------------------------------------------------------
// foCX񃊃Xg̃oCgTCY
#define GET_HPCDEVICEINFOLIST_SIZE( count ) \
		(sizeof(HPCDEVICEINFOLIST) + (sizeof(HPCDEVICEINFO) * ((count) - 1)))

#define HPC_INVALID_HANDLE ((DWORD)INVALID_HANDLE_VALUE)

// ----------------------------------------------------------------------------
//	֐vg^Cv
// ----------------------------------------------------------------------------
#ifdef __cplusplus
extern "C"
{
#endif

// {[h̎擾(F_~[)
__declspec(dllimport) DWORD WINAPI hppd553_GetDeviceCount(WORD dummy);

// foCX̎擾(FfoCX̌AfoCX񃊃Xg̐擪AhX)
__declspec(dllimport) DWORD WINAPI hppd553_GetDeviceInfo(DWORD* pcnDevNum, PHPCDEVICEINFO pHpcDevInfo);

// foCX̃I[v({[hIDQ)(FfoCX̃AhX)
__declspec(dllimport) DWORD WINAPI hppd553_OpenDeviceID(PHPCDEVICEINFO pHpcDevInfo);

// foCX̃I[v({[hID)(FfoCX̃AhX)
__declspec(dllimport) DWORD WINAPI hppd553_OpenDevice(PHPCDEVICEINFO pHpcDevInfo);

// foCXN[Y(FHPCI foCXID (nh))
__declspec(dllimport) DWORD WINAPI hppd553_CloseDevice(DWORD hDevID);

// R}hobt@(FHPCI foCXID (nh)Ajbgԍ(w)Apf[^AWX^XCb`AWX^pf[^(ElSoCg))
__declspec(dllimport) DWORD WINAPI hppd553_CmdWrite(DWORD hDevID, WORD AxisNo, BYTE byData, WORD sw, DWORD dwReg);

// 샂[hobt@(FHPCI foCXID (nh)Ajbgԍ(w)Apf[^)
__declspec(dllimport) DWORD WINAPI hppd553_DousaWrite(DWORD hDevID, WORD AxisNo, BYTE byData);

// 䃂[hobt@(FHPCI foCXID (nh)Ajbgԍ(w)Apf[^)
__declspec(dllimport) DWORD WINAPI hppd553_SeigyoWrite(DWORD hDevID, WORD AxisNo, BYTE byData);

// Xe[^XPǍ(FHPCI foCXID (nh)Ajbgԍ(w)Af[^i[)
__declspec(dllimport) DWORD WINAPI hppd553_status1Read(DWORD hDevID, WORD AxisNo, BYTE* bySts1);

// Xe[^XQǍ(FHPCI foCXID (nh)Ajbgԍ(w)Af[^i[)
__declspec(dllimport) DWORD WINAPI hppd553_status2Read(DWORD hDevID, WORD AxisNo, BYTE* bySts2);

// Xe[^XǍ(FHPCI foCXID (nh)Ajbgԍ(w)Af[^i[)
__declspec(dllimport) DWORD WINAPI hppd553_intstatusRead(DWORD hDevID, WORD AxisNo, BYTE* byIntSts);

// WX^Ǎ(FHPCI foCXID (nh)Ajbgԍ(w)AWX^ǍR}hAf[^i[(El))
__declspec(dllimport) DWORD WINAPI hppd553_regRead(DWORD hDevID, WORD AxisNo, BYTE byData, DWORD* dwReg);

// ėp̓|[goCgǍ(FHPCI foCXID (nh)A|[gԍAf[^i[)
__declspec(dllimport) DWORD WINAPI hppd553_inpReadB(DWORD hDevID, WORD PortNo, BYTE* byInp);

// ėp̓|[g[hǍ(FHPCI foCXID (nh)Af[^i[)
__declspec(dllimport) DWORD WINAPI hppd553_inpReadW(DWORD hDevID, WORD* wInp);

// ėpo̓|[goCg(FHPCI foCXID (nh)A|[gԍApf[^)
__declspec(dllimport) DWORD WINAPI hppd553_outpWriteB(DWORD hDevID, WORD PortNo, BYTE byData);

// ėpo̓|[g[h(FHPCI foCXID (nh)Apf[^)
__declspec(dllimport) DWORD WINAPI hppd553_outpWriteW(DWORD hDevID, WORD wData);

// ėpo̓|[goCgǍ(FHPCI foCXID (nh)A|[gԍAf[^i[)
__declspec(dllimport) DWORD WINAPI hppd553_outpReadB(DWORD hDevID, WORD PortNo, BYTE* byOutp);

// ėpo̓|[g[hǍ(FHPCI foCXID (nh)Af[^i[)
__declspec(dllimport) DWORD WINAPI hppd553_outpReadW(DWORD hDevID, WORD* wOutp);

// ėpo͐ؑփ|[g(FHPCI foCXID (nh)Apf[^)
__declspec(dllimport) DWORD WINAPI hppd553_ioswWrite(DWORD hDevID, BYTE byData);

// ėpo͐ؑփ|[gǍ(FHPCI foCXID (nh)Af[^i[)
__declspec(dllimport) DWORD WINAPI hppd553_ioswRead(DWORD hDevID, BYTE* byIoSw);

// ELSɐI|[g(FHPCI foCXID (nh)Apf[^)
__declspec(dllimport) DWORD WINAPI hppd553_ElstWrite(DWORD hDevID, BYTE byData);

// ELSɐI|[gǍ(FHPCI foCXID (nh)Af[^i[)
__declspec(dllimport) DWORD WINAPI hppd553_ElstRead(DWORD hDevID, BYTE* byElsData);

// Rp[^X^[g(FHPCI foCXID (nh)Apf[^)
__declspec(dllimport) DWORD WINAPI hppd553_CmpcWrite(DWORD hDevID, BYTE byData);

// Rp[^X^[gǍ(FHPCI foCXID (nh)Af[^i[)
__declspec(dllimport) DWORD WINAPI hppd553_CmpcRead(DWORD hDevID, BYTE* byCmpData);

// ėp͂ɂ铯X^[gEXgbv(FHPCI foCXID (nh)Apf[^)
__declspec(dllimport) DWORD WINAPI hppd553_diWrite(DWORD hDevID, BYTE byData);

// ėp͂ɂ铯X^[gEXgbvǍ(FHPCI foCXID (nh)Af[^i[)
__declspec(dllimport) DWORD WINAPI hppd553_diRead(DWORD hDevID, BYTE* byDi);

#ifdef __cplusplus
}
#endif
